#include "progs.h"

extern _GfxWin *mainwin;
extern struct _globalgui _GlobalGUI;
extern struct _wconfig _WConfig;
extern bool ende;
extern char *_locale[];
extern char *_localecoms[];
extern char *_localeflags[];
extern int _NBH;
extern int _BBH;
extern int _CharWidth,_CharHeight;
extern int errno;
extern int flaginfo[COMNR][2];
extern _MainStruct mainstruct;
extern char *home;

int _Request(char *title,int lines,char *text[],int buttons,char *buttontext[])
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  int w,h,buttonw,w2;
  int x,y,xx;
  int choose;
  for(x=1,y=0;x<lines;x++) {
    if(strlen(text[x])>strlen(text[y])) y=x;
  }
  w=strlen(text[y])+4;
  w*=_CharWidth;
  w2=10+10+(buttons-1)*10;
  for(x=0;x<buttons;x++) {
    w2+=(strlen(buttontext[x])+2)*_CharWidth;
  }
  if(w2>w) w=w2;
  h=lines*_NBH+2*_BBH;
  choose=0;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,title,PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    for(x=0;x<lines;x++) {
      _CreateText(gfxwin,10,5+_CharHeight+x*_NBH,_WConfig.requestfg,text[x]);
    }
    xx=10;
    for(x=0;x<(buttons-1);x++) {
      buttonw=(strlen(buttontext[x])+2)*_CharWidth;
      _CreateButton(gfxwin,xx,h-_BBH-5,buttonw,_BBH,_black,_WConfig.requestbg,buttontext[x],FALSE,0,0,"",x);
      xx+=buttonw+10;
    }
    buttonw=(strlen(buttontext[buttons-1])+2)*_CharWidth;
    if(buttons>1) {
      _CreateButton(gfxwin,w-10-buttonw,h-_BBH-5,buttonw,_BBH,_black,_WConfig.requestbg,buttontext[buttons-1],FALSE,0,0,"",buttons-1);
    } else {
      /* nur ein Button => lieber in die Mitte stellen */
      _CreateButton(gfxwin,(w-buttonw)/2,h-_BBH-5,buttonw,_BBH,_black,_WConfig.requestbg,buttontext[buttons-1],FALSE,0,0,"",0);
    }
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            choose=tbutton->data;
            _ReplyMessage(msg);
            break;
          }
        } else if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            choose=0;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            choose=buttons-1;
            _ReplyMessage(msg);
            break;
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            if(msg->window==gfxwin->Wnd) {
              choose=buttons-1;
              _ReplyMessage(msg);
              break;
            }
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return choose;
}

void _QuitOp(int pointerinfo,void *info)
{
  char *text[1];
  char *btext[2];
  int choose;
  long flag;
  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef *)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef *)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef *)info)->flag1;
  } else flag=0;
  if(flag==0) {
    text[0]=_locale[115];
    btext[0]=_locale[11];
    btext[1]=_locale[8];
    choose=_Request(_locale[114],1,text,2,btext);
  } else choose=0;
  if(choose==0) ende=TRUE; else ende=FALSE;
}

void _LoadListerSettings(void)
{
  /* zu ladene Informationen :
    mainstruct.lister[x].activemode->mainstruct.loadsets.activemode[x]
    mainstruct.lister[x].first_filter
    mainstruct.lister[x].sortmode
    mainstruct.lister[x].reverse
    mainstruct._ActiveLV->mainstruct.loadsets._ActiveLV */
  FILE *fp;
  char *file;
  int x,y;
  unsigned short t;
  long error,len;
  bool ende;
  _Filter *filter=NULL,*ff,*tf;
  
  mainstruct.loadsets.activemode[0]=-1;
  mainstruct.loadsets.activemode[1]=-1;
  mainstruct.loadsets._ActiveLV=-1;
  file=(char*)_allocsafe(strlen(home)+11);
  strcpy(file,home);
  strcat(file,"/tsettings");
  if((fp=fopen(file,"r"))!=NULL) {
    for(x=0;x<2;x++) {
      t=_FGetInt(&error,fp);
      if(t==65535) mainstruct.loadsets.activemode[x]=-1;
      else mainstruct.loadsets.activemode[x]=t;
      t=_FGetInt(&error,fp);
      if(t==65535) mainstruct.lister[x].sortmode=-1;
      else mainstruct.lister[x].sortmode=t;
      ff=NULL;
      ende=FALSE;
      do {
        t=_FGetInt(&error,fp);
        y=(int)t;
        if(t==65535) ende=TRUE;
        else {
          tf=(_Filter*)_allocsafe(sizeof(_Filter));
          tf->check=y;
          len=_FGetLong(&error,fp);
          tf->pattern=_FGetString(len,fp);
          tf->next=NULL;
          if(ff==NULL) {
            ff=tf;
          } else {
            filter->next=tf;
          }
          filter=tf;
        }
      } while(ende==FALSE);
      mainstruct.lister[x].first_filter=ff;
    }
    t=_FGetInt(&error,fp);
    if(t==65535) mainstruct.loadsets._ActiveLV=-1;
    else mainstruct.loadsets._ActiveLV=t;
    fclose(fp);
  }
  _freesafe(file);
}

void _SaveListerSettings(void)
{
  /* zu speichernde Informationen :
    mainstruct.lister[x].activemode
    mainstruct.lister[x].first_filter
    mainstruct.lister[x].sortmode
    mainstruct._ActiveLV */
  FILE *fp;
  char *file;
  int x;
  _Filter *filter;
  file=(char*)_allocsafe(strlen(home)+11);
  strcpy(file,home);
  strcat(file,"/tsettings");
  if((fp=fopen(file,"w"))!=NULL) {
    for(x=0;x<2;x++) {
      _FPutInt(mainstruct.lister[x].activemode,fp);
      _FPutInt(mainstruct.lister[x].sortmode,fp);
      filter=mainstruct.lister[x].first_filter;
      while(filter!=NULL) {
        _FPutInt(filter->check,fp);
        _FPutLong(strlen(filter->pattern),fp);
        _FPutString(filter->pattern,fp);
        filter=filter->next;
      }
      _FPutInt(-1,fp);       /* Abschlu-Zeichen */
    }
    _FPutInt(mainstruct._ActiveLV,fp);
    fclose(fp);
  }
  _freesafe(file);
}

void signalquit()
{
  ende=TRUE;
}

void _InitWorker(void)
{
  _RealLister *rl;
  _IMInfo *imi;
  int x,y;
  time_t timep;

  time(&timep);
  srand((int)timep);

  for(x=0;x<2;x++) {
    mainstruct.lister[x].lv=NULL;
    mainstruct.lister[x].activemode=-1;
    mainstruct.lister[x].first_filter=NULL;
    mainstruct.lister[x].filter_changed=TRUE;
    mainstruct.lister[x].sortmode=SORT_NAME;
  }
  mainstruct._ActiveLV=-1;
  /* Lade Informationen vvv*/
  _LoadListerSettings();
  /* Lade Informationen ^^^*/
  for(y=0;y<LISTER_MODES;y++) {
    for(x=0;x<COMNR;x++) {
      mainstruct.mode_info[y].prog[x]=NULL;
    }
  }
  /*vvv Einzelne Module initieren vvv*/
  /*vvv Modul: Normale Dateianzeige vvv*/
  mainstruct.mode_info[0].activate=_NL_activate;
  mainstruct.mode_info[0].deactivate=_NL_deactivate;
  mainstruct.mode_info[0].on=_NL_on;
  mainstruct.mode_info[0].off=_NL_off;
  mainstruct.mode_info[0].shutdown=_NL_Shutdown;
  mainstruct.mode_info[0].update=_NL_RebuildLister;
  mainstruct.mode_info[0].name=_locale[173];
  mainstruct.mode_info[0].selectable=TRUE;
  rl=(_RealLister*)_allocsafe(sizeof(_RealLister));
  mainstruct.mode_info[0].special_info=rl;
  rl->Dir[0]=NULL;
  rl->Dir[1]=NULL;
  rl->FEDir[0]=NULL;
  rl->FEDir[1]=NULL;
  rl->nextcheck[0]=NULL;
  rl->nextcheck[1]=NULL;
  rl->filesunchecked=0;
  rl->dirnr[0][0]=0;
  rl->dirnr[0][1]=0;
  rl->dirnr[1][0]=0;
  rl->dirnr[1][1]=0;
  rl->filenr[0][0]=0;
  rl->filenr[0][1]=0;
  rl->filenr[1][0]=0;
  rl->filenr[1][1]=0;
  rl->selbytes[0]=0;
  rl->selbytes[1]=0;
  rl->activefe[0]=NULL;
  rl->activefe[1]=NULL;
  mainstruct.mode_info[0].prog[QUIT]=_QuitOp;
  mainstruct.mode_info[0].prog[PREVITEM]=_NL_Up;
  mainstruct.mode_info[0].prog[NEXTITEM]=_NL_Down;
  mainstruct.mode_info[0].prog[PARENT]=_NL_Left;
  mainstruct.mode_info[0].prog[GODIR]=_NL_Right;
  mainstruct.mode_info[0].prog[FIRSTITEM]=_NL_Home;
  mainstruct.mode_info[0].prog[LASTITEM]=_NL_End;
  mainstruct.mode_info[0].prog[PAGEUP]=_NL_PageUp;
  mainstruct.mode_info[0].prog[PAGEDOWN]=_NL_PageDown;
  mainstruct.mode_info[0].prog[SELECT]=_NL_SelectActive;
  mainstruct.mode_info[0].prog[SELECTALL]=_NL_SelectAllOp;
  mainstruct.mode_info[0].prog[SELECTNONE]=_NL_SelectNoneOp;
  mainstruct.mode_info[0].prog[INVERT]=_NL_InvertOp;
  mainstruct.mode_info[0].prog[COPY]=_NL_CopyOp;
  mainstruct.mode_info[0].prog[DELETE]=_NL_DeleteOp;
  mainstruct.mode_info[0].prog[RENAME]=_NL_RenameOp;
  mainstruct.mode_info[0].prog[MAKEDIR]=_NL_MakeDirOp;
  mainstruct.mode_info[0].prog[MOVE]=_NL_MoveOp;
  mainstruct.mode_info[0].prog[USER]=_NL_UserCom;
  mainstruct.mode_info[0].prog[RELOAD]=_NL_UpdateDir;
  mainstruct.mode_info[0].prog[RUNPROGRAM]=_NL_RunProgram;
  mainstruct.mode_info[0].prog[MAIN_FUNC]=_NL_MainFunc;
  mainstruct.mode_info[0].prog[LISTEROPTIONS]=_ALL_ChangeListerOptions;
  mainstruct.mode_info[0].prog[LISTERSCROLLLEFT]=_ALL_ListerScrollLeft;
  mainstruct.mode_info[0].prog[LISTERSCROLLRIGHT]=_ALL_ListerScrollRight;
  mainstruct.mode_info[0].prog[FILTERSELECT]=_NL_FilterSelect;
  mainstruct.mode_info[0].prog[DIRSIZE]=_NL_DirSize;
  mainstruct.mode_info[0].prog[CREATESYMLINK]=_NL_CreateSymlink;
  mainstruct.mode_info[0].prog[CHANGESYMLINK]=_NL_ChangeSymlink;
  mainstruct.mode_info[0].prog[CHANGEMOD]=NL_ChangeMOD;
  mainstruct.mode_info[0].prog[TOGGLEINFOMODE]=NL_ToggleInfoMode;
  mainstruct.mode_info[0].prog[SEARCHENTRY]=NL_SearchEntry;
  mainstruct.mode_info[0].prog[PATH2OTHERLISTER]=NL_Path2OtherLister;
  mainstruct.mode_info[0].prog[ENTERPATH]=NL_EnterPath;
  mainstruct.mode_info[0].internprog[0]=_NL_CheckAction;
  /*^^^ Modul: Normale Dateianzeige, Init beendet ^^^*/
  /*vvv Modul: Informationsanzeige vvv*/
  mainstruct.mode_info[1].activate=_IM_activate;
  mainstruct.mode_info[1].deactivate=_IM_deactivate;
  mainstruct.mode_info[1].on=_IM_on;
  mainstruct.mode_info[1].off=_IM_off;
  mainstruct.mode_info[1].shutdown=_IM_Shutdown;
  mainstruct.mode_info[1].update=_IM_Update;
  mainstruct.mode_info[1].name=_locale[174];
  mainstruct.mode_info[1].selectable=TRUE;
  mainstruct.mode_info[1].special_info=NULL;
  mainstruct.mode_info[1].prog[QUIT]=_QuitOp;
  mainstruct.mode_info[1].prog[LISTEROPTIONS]=_ALL_ChangeListerOptions;
  mainstruct.mode_info[1].prog[LISTERSCROLLLEFT]=_ALL_ListerScrollLeft;
  mainstruct.mode_info[1].prog[LISTERSCROLLRIGHT]=_ALL_ListerScrollRight;
/*  mainstruct.mode_info[1].internprog[0]=_NL_CheckAction;*/
  imi=(_IMInfo*)_allocsafe(sizeof(_IMInfo));
  mainstruct.mode_info[1].special_info=imi;
  imi->update[0]=FALSE;
  imi->update[1]=FALSE;
  imi->lastmode[0]=-1;
  imi->lastmode[1]=-1;
  imi->finished[0]=TRUE;
  imi->finished[1]=TRUE;
  /*^^^ Modul: Informationsanzeige, Init beendet ^^^*/
  /* vvv Signale abfangen */
  signal(SIGTERM,signalquit);
  signal(SIGQUIT,signalquit);
  signal(SIGABRT,signalquit);
}

void _ShutdownWorker(void)
{
  _Filter *fil,*fil2;
  int nr;
  void (*shutdown)(void);

  for(nr=0;nr<2;nr++) {
    fil=mainstruct.lister[nr].first_filter;
    while(fil!=NULL) {
      fil2=fil->next;
      _freesafe(fil->pattern);
      _freesafe(fil);
      fil=fil2;
    }
  }
  for(nr=0;nr<LISTER_MODES;nr++) {
    shutdown=mainstruct.mode_info[nr].shutdown;
    if(shutdown!=NULL) (*shutdown)();
  }
}

void _About(void)
{
  char *buttontext[1];
  char *infotext[20],*tstr;
  char buffer[128];
  int lines,x;
#ifdef USE_MEM_SYSTEM
  extern unsigned long memusage;
  extern unsigned long maxmemusage;
#endif
  buttontext[0]=_locale[11];
  sprintf(buffer,"Worker %d.%d.%d",MAJOR,MINOR,PATCH);
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[0]=tstr;
  strcpy(buffer,"");
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[1]=tstr;
  sprintf(buffer,"(C) by Ralf Hoffmann");
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[2]=tstr;
  sprintf(buffer,"  Distributed under GNU General Public License");
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[3]=tstr;
  strcpy(buffer,"");
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[4]=tstr;
  lines=5;
#ifdef ZLIB
  sprintf(buffer,"This program transparently decompress GZIPed-files");
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[lines++]=tstr;
#endif
#ifdef USE_MEM_SYSTEM
  sprintf(buffer,"This program is compiled with the SLOW memory-system!");
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[lines++]=tstr;
  sprintf(buffer,"  Memusage:%ld",memusage);
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[lines++]=tstr;
  sprintf(buffer,"  maximal Memusage:%ld",maxmemusage);
  tstr=(char*)_allocsafe(strlen(buffer)+1);
  strcpy(tstr,buffer);
  infotext[lines++]=tstr;
#endif
  _Request(_locale[208],lines,infotext,1,buttontext);
  for(x=0;x<lines;x++) {
    _freesafe(infotext[x]);
  }
}

bool _EditFilter(_Filter *filter)
{
  _GfxWin *gfxwin;
  _StringGadget *sg;
  _Button *tbutton;
  _Message *msg;
  _ChooseButton *cb[2],*tcb;
  int w,h,okw,cancelw,th,m;
  bool returnvalue=TRUE;
  w=strlen(_locale[93])+1;
  w*=_CharWidth;
  w+=10+10+100;
  h=5*_BBH+5;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,_locale[172],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    okw=_CharWidth*(strlen(_locale[11])+2);
    cancelw=_CharWidth*(strlen(_locale[8])+2);
    _CreateButton(gfxwin,10,h-5-_BBH,okw,_BBH,1,0,_locale[11],FALSE,0,0,"",-1);
    _CreateButton(gfxwin,w-10-cancelw,h-5-_BBH,cancelw,_BBH,1,0,_locale[8],FALSE,0,0,"",-2);
    _CreateText(gfxwin,10,5+_CharHeight,1,_locale[93]);
    sg=_CreateStringGadget(gfxwin,15+_CharWidth*strlen(_locale[93]),5,w-10-15-_CharWidth*strlen(_locale[93]),_BBH,filter->pattern,1024,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,1);
    th=5+_BBH+5;
    m=NORMAL;
    if(filter->check==1) m=HIGH;
    cb[0]=_CreateChooseButton(gfxwin,10,th,_BBH,_BBH,m,2);
    _CreateText(gfxwin,10+_BBH+5,th+_CharHeight,1,_locale[170]);
    th+=_BBH+5;
    m=NORMAL;
    if(filter->check==2) m=HIGH;
    cb[1]=_CreateChooseButton(gfxwin,10,th,_BBH,_BBH,m,3);
    _CreateText(gfxwin,10+_BBH+5,th+_CharHeight,1,_locale[171]);
    _RedrawWin(gfxwin);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==-1) {
              /* OK */
              _freesafe(filter->pattern);
              filter->pattern=(char*)_allocsafe(strlen(sg->string)+1);
              strcpy(filter->pattern,sg->string);
              if(cb[0]->data==HIGH) filter->check=1;
              else if(cb[1]->data==HIGH) filter->check=2;
              else filter->check=0;
              _ReplyMessage(msg);
              break;
            } else if(tbutton->data==-2) {
              _ReplyMessage(msg);
              returnvalue=FALSE;
              break;
            }
          }
        } else if(msg->type==ButtonPress) {
          if(msg->gadgettype==CHOOSE_GADGET) {
            tcb=(_ChooseButton*)msg->gadget;
            if(tcb->data==HIGH) {
              if(tcb==cb[0]) cb[1]->data=NORMAL; else cb[0]->data=NORMAL;
              _RedrawWin(gfxwin);
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            if(msg->window==gfxwin->Wnd) {
              _ReplyMessage(msg);
              returnvalue=FALSE;
              break;
            }
          }
        }
        _ReplyMessage(msg);
      }
    }
    _CloseWindow(gfxwin);
  }
  return returnvalue;
}

void _ChangeListerSets(int nr)
{
  _GfxWin *gfxwin,*wins[3],*actwin;
  _Button *tbutton;
  _Message *msg;
  _ChooseButton *cb[6],*tcb,*cbmode[LISTER_MODES];
  _ListView *flv;
  _ListViewContent *lastlvc,*tlvc;
  _Filter *f,*localf,*tf,*tf2,*tf3;
  char buffer[1024];
  int w,wt[3],wt2[LISTER_MODES],h,sw,a,b,c,okw,cancelw,sortmode=0,tx;
  int selmodes,i,j,k;
  int newmode,taste;
  void (*prog)(int);
  bool conti,cancel,ok;

  h=10+_BBH+6*_BBH+8*5+10+_BBH;
  w=strlen(_locale[160]);
  for(a=1;a<6;a++) {
    if(strlen(_locale[160+a])>w) w=strlen(_locale[160+a]);
  }
  w*=_CharWidth;
  w+=10+10+5+_BBH;
  wt[0]=strlen(_locale[158])+strlen(_locale[159])+strlen(_locale[166])+6;
  wt[0]*=_CharWidth;
  wt[0]+=10;
  wt[1]=strlen(_locale[167])+strlen(_locale[168])+strlen(_locale[169])+6;
  wt[1]*=_CharWidth;
  wt[1]+=10+20+10;
  for(a=0,b=0;a<LISTER_MODES;a++) {
    if(mainstruct.mode_info[a].selectable==TRUE) {
      wt2[b]=strlen(mainstruct.mode_info[a].name);
      b++;
    }
  }
  selmodes=b;
  c=selmodes*(5+_BBH);
  c+=5+_BBH+5+5+5+_BBH+5;
  if(c>h) h=c;
  if(wt[0]>w) w=wt[0];
  if(wt[1]>w) w=wt[1];
  for(a=0,b=0;a<selmodes;a++) {
    if(wt2[a]>wt2[b]) b=a;
  }
  wt[2]=wt2[b]*_CharWidth;
  wt[2]+=5+_BBH+5+10;
  if(wt[2]>w) w=wt[2];
  /* lokale Kopie erstellen */
  f=mainstruct.lister[nr].first_filter;
  localf=NULL;
  tf2=NULL;
  while(f!=NULL) {
    tf=(_Filter*)_allocsafe(sizeof(_Filter));
    tf->check=f->check;
    tf->pattern=(char*)_allocsafe(strlen(f->pattern)+1);
    strcpy(tf->pattern,f->pattern);
    tf->next=NULL;
    if(localf==NULL) {
      localf=tf;
    } else tf2->next=tf;
    tf2=tf;
    f=f->next;
  }
  /* lokale Kopie erstellt */
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,_locale[16],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    okw=_CharWidth*(strlen(_locale[11])+2);
    cancelw=_CharWidth*(strlen(_locale[8])+2);
    a=strlen(_locale[158])+2;
    a*=_CharWidth;
    b=strlen(_locale[159])+2;
    b*=_CharWidth;
    c=strlen(_locale[166])+2;
    c*=_CharWidth;
    /* Definiere Modus-Unterfenster */
    wins[2]=_OpenWindow(gfxwin,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,"",PMinSize|PMaxSize,NULL);
    _CreateButton(wins[2],5,5,a,_BBH,1,0,_locale[158],FALSE,0,0,"",1);
    _CreateButton(wins[2],5+a,5,b,_BBH,1,0,_locale[159],FALSE,0,0,"",2);
    _CreateButton(wins[2],5+a+b,10,c,_BBH,1,0,_locale[166],FALSE,0,0,"",3);
    for(i=0,k=0;i<LISTER_MODES;i++) {
      if(mainstruct.mode_info[i].selectable==TRUE) {
        if(mainstruct.lister[nr].activemode==i) j=HIGH; else j=NORMAL;
        cbmode[k]=_CreateChooseButton(wins[2],10,10+_BBH+(k+1)*5+k*_BBH,_BBH,_BBH,j,i+1);
        _CreateText(wins[2],15+_BBH,10+_BBH+(k+1)*5+k*_BBH+_CharHeight+1,1,mainstruct.mode_info[i].name);
        k++;
      }
    }
    /* Definiere Filter-Unterfenster */
    wins[1]=_OpenWindow(gfxwin,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,"",PMinSize|PMaxSize,NULL);
    _CreateButton(wins[1],5,5,a,_BBH,1,0,_locale[158],FALSE,0,0,"",1);
    _CreateButton(wins[1],5+a,10,b,_BBH,1,0,_locale[159],FALSE,0,0,"",2);
    _CreateButton(wins[1],5+a+b,5,c,_BBH,1,0,_locale[166],FALSE,0,0,"",3);
    sw=strlen(_locale[167])+2;
    sw*=_CharWidth;
    tx=10;
    _CreateButton(wins[1],tx,h-5-_BBH-5-5-_BBH,sw,_BBH,1,0,_locale[167],FALSE,0,0,"",10);
    tx+=sw+10;
    sw=strlen(_locale[168])+2;
    sw*=_CharWidth;
    _CreateButton(wins[1],tx,h-5-_BBH-5-5-_BBH,sw,_BBH,1,0,_locale[168],FALSE,0,0,"",11);
    tx+=sw+10;
    sw=strlen(_locale[169])+2;
    sw*=_CharWidth;
    _CreateButton(wins[1],tx,h-5-_BBH-5-5-_BBH,sw,_BBH,1,0,_locale[169],FALSE,0,0,"",12);
    flv=_CreateListView(wins[1],10,10+_BBH+5,w-20,h-35-3*_BBH,TRUE,FALSE,10,TRUE,FALSE,10,NULL,14);
    tf=localf;
    lastlvc=NULL;
    while(tf!=NULL) {
      sprintf(buffer,"%s   ",tf->pattern);
      switch(tf->check) {
        case 1:strcat(buffer,_locale[170]);
               break;
        case 2:strcat(buffer,_locale[171]);
               break;
      }
      lastlvc=_AddListViewContent(flv,lastlvc,buffer,0);
      tf=tf->next;
    }
    /* Definiere Sort-Unterfenster */
    wins[0]=_OpenWindow(gfxwin,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,"",PMinSize|PMaxSize,NULL);
    _CreateButton(wins[0],5,10,a,_BBH,1,0,_locale[158],FALSE,0,0,"",1);
    _CreateButton(wins[0],5+a,5,b,_BBH,1,0,_locale[159],FALSE,0,0,"",2);
    _CreateButton(wins[0],5+a+b,5,c,_BBH,1,0,_locale[166],FALSE,0,0,"",3);
    for(a=0;a<5;a++) {
      if((mainstruct.lister[nr].sortmode&0x7f)==a) b=HIGH; else b=NORMAL;
      cb[a]=_CreateChooseButton(wins[0],10,10+_BBH+(a+1)*5+a*_BBH,_BBH,_BBH,b,a+1);
      _CreateText(wins[0],15+_BBH,10+_BBH+(a+1)*5+a*_BBH+_CharHeight+1,1,_locale[160+a]);
    }
    if((mainstruct.lister[nr].sortmode&0x80)==0x80) 
      cb[5]=_CreateChooseButton(wins[0],10,10+_BBH+(a+2)*5+a*_BBH,_BBH,_BBH,HIGH,a+1);
    else
      cb[5]=_CreateChooseButton(wins[0],10,10+_BBH+(a+2)*5+a*_BBH,_BBH,_BBH,NORMAL,a+1);
    _CreateText(wins[0],15+_BBH,10+_BBH+(a+2)*5+a*_BBH+_CharHeight+1,1,_locale[160+a]);
    /* Erstelle TeilGUI, die fr alle Unterfenster gelten */
    for(a=0;a<3;a++) {
      _CreateButton(wins[a],10,h-5-_BBH,okw,_BBH,1,0,_locale[11],FALSE,0,0,"",-1);
      _CreateButton(wins[a],w-10-cancelw,h-5-_BBH,cancelw,_BBH,1,0,_locale[8],FALSE,0,0,"",-2);
      _CreateBevelBox(wins[a],5,10+_BBH,w-10,h-5-_BBH-5-10-_BBH,NORMAL);
      _RedrawWin(wins[a]);
    }
    actwin=wins[0];
    cancel=FALSE;
    ok=FALSE;
    /* vvv Habe ich hinzugefgt, da beim Benutzen des Hotkeys fr das ndern
           immer das F2 noch im Buffer war vvv*/
    while((msg=_GetMessage(actwin))!=NULL) _ReplyMessage(msg);
    /* ^^^^^^*/
    for(;;) {
      if((msg=_WaitMessage(actwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if((tbutton->data>0)&&(tbutton->data<4)) {
              XRaiseWindow(_GlobalGUI.Dsp,wins[tbutton->data-1]->Wnd);
              actwin=wins[tbutton->data-1];
            } else if(tbutton->data==-1) {
              /* OK */
              ok=TRUE;
              _ReplyMessage(msg);
              break;
            } else if(tbutton->data==-2) {
              cancel=TRUE;
              _ReplyMessage(msg);
              break;
            } else if(tbutton->data==10) {
              if(actwin==wins[1]) {
                lastlvc=flv->first;
                if(lastlvc!=NULL) {
                  while(lastlvc->next!=NULL) {
                    lastlvc=lastlvc->next;
                  }
                }
                tf=localf;
                if(tf!=NULL) {
                  while(tf->next!=NULL) {
                    tf=tf->next;
                  }
                }
                tf2=(_Filter*)_allocsafe(sizeof(_Filter));
                tf2->check=0;
                tf2->pattern=(char*)_allocsafe(1);
                strcpy(tf2->pattern,"");
                tf2->next=NULL;
                if(tf==NULL) localf=tf2; else tf->next=tf2;
                _EditFilter(tf2);
                sprintf(buffer,"%s   ",tf2->pattern);
                switch(tf2->check) {
                  case 1:strcat(buffer,_locale[170]);
                         break;
                  case 2:strcat(buffer,_locale[171]);
                         break;
                }
                _AddListViewContent(flv,lastlvc,buffer,0);
                _RedrawWin(wins[1]);
              }
            } else if(tbutton->data==11) {
              if(actwin==wins[1]) {
                tf=localf;
                tlvc=flv->first;
                conti=TRUE;
                while((tlvc!=NULL)&&(conti==TRUE)) {
                  if(tlvc->select==TRUE) {
                    conti=_EditFilter(tf);
                    sprintf(buffer,"%s   ",tf->pattern);
                    switch(tf->check) {
                      case 1:strcat(buffer,_locale[170]);
                             break;
                      case 2:strcat(buffer,_locale[171]);
                             break;
                    }
                    a=strlen(buffer);
                    _freesafe(tlvc->text);
                    tlvc->text=(char*)_allocsafe(strlen(buffer)+1);
                    strcpy(tlvc->text,buffer);
                    if(flv->maxlength<a) flv->maxlength=a;
                    tlvc->select=FALSE;
                    _RedrawWin(wins[1]);
                  }
                  tlvc=tlvc->next;
                  tf=tf->next;
                }
              }
            } else if(tbutton->data==12) {
              if(actwin==wins[1]) {
                tf=localf;
                tf2=NULL;
                tlvc=flv->first;
                while(tlvc!=NULL) {
                  tf3=tf->next;
                  if(tlvc->select==TRUE) {
                    if(tf2==NULL) {
                      localf=tf3;
                    } else {
                      tf2->next=tf3;
                    }
                    _freesafe(tf->pattern);
                    _freesafe(tf);
                    _RemoveListViewContent(wins[1],flv,tlvc);
                    _RedrawWin(wins[1]);
                  } else {
                    tf2=tf;
                  }
                  tlvc=tlvc->next;
                  tf=tf3;
                }
              }
            }
          }
        } else if(msg->type==ButtonPress) {
          if(actwin==wins[0]) {
            if(msg->gadgettype==CHOOSE_GADGET) {
              tcb=(_ChooseButton*)msg->gadget;
              if((tcb->data2>=1)&&(tcb->data2<6)) {
                if(tcb->data==NORMAL) {
                  tcb->data=HIGH;
                  _RedrawWin(wins[0]);
                } else {
                  for(a=1;a<tcb->data2;a++) {
                    cb[a-1]->data=NORMAL;
                  }
                  for(a=tcb->data2+1;a<6;a++) {
                    cb[a-1]->data=NORMAL;
                  }
                  _RedrawWin(wins[0]);
                }
              }
            }
          } else if(actwin==wins[2]) {
            if(msg->gadgettype==CHOOSE_GADGET) {
              tcb=(_ChooseButton*)msg->gadget;
              if((tcb->data2>=1)&&(tcb->data2<=selmodes)) {
                if(tcb->data==HIGH) {
                  for(a=1;a<tcb->data2;a++) {
                    cbmode[a-1]->data=NORMAL;
                  }
                  for(a=tcb->data2+1;a<=selmodes;a++) {
                    cbmode[a-1]->data=NORMAL;
                  }
                  _RedrawWin(wins[2]);
                }
              }
            }
          }
        } else if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            ok=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            cancel=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_F1) {
            XRaiseWindow(_GlobalGUI.Dsp,wins[0]->Wnd);
            actwin=wins[0];
          } else if(msg->key==XK_F2) {
            XRaiseWindow(_GlobalGUI.Dsp,wins[1]->Wnd);
            actwin=wins[1];
          } else if(msg->key==XK_F3) {
            XRaiseWindow(_GlobalGUI.Dsp,wins[2]->Wnd);
            actwin=wins[2];
          } else if((msg->key>=XK_0)&&(msg->key<=XK_9)) {
            taste=msg->key-XK_0;
            if(actwin==wins[0]) {
              if((taste>=1)&&(taste<6)) {
                tcb=cb[taste-1];
                if(tcb->data==NORMAL) {
                  for(a=0;a<5;a++) {
                    cb[a]->data=NORMAL;
                  }
                  tcb->data=HIGH;
                }
              } else if(taste==6) {
                tcb=cb[taste-1];
                if(tcb->data==NORMAL) tcb->data=HIGH; else tcb->data=NORMAL;
              }
              _RedrawWin(wins[0]);
            } else if(actwin==wins[2]) {
              if((taste>=1)&&(taste<=selmodes)) {
                tcb=cbmode[taste-1];
                if(tcb->data==NORMAL) {
                  for(a=0;a<selmodes;a++) {
                    cbmode[a]->data=NORMAL;
                  }
                  tcb->data=HIGH;
                } else {
                  tcb->data=NORMAL;
                }
                _RedrawWin(wins[2]);
              }
            }
          }
        } else if(msg->type==ClientMessage) {
          if(msg->gadgettype==CLOSE_GADGET) {
            if(msg->window==gfxwin->Wnd) {
              _ReplyMessage(msg);
              break;
            }
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(ok==TRUE) {
      for(a=0;a<5;a++) {
        if(cb[a]->data==HIGH) sortmode=a;
      }
      if(cb[5]->data==HIGH) {
        sortmode=sortmode|0x80;
      } else {
        sortmode=sortmode&0x7f;
      }
      mainstruct.lister[nr].sortmode=sortmode;
      mainstruct.lister[nr].filter_changed=TRUE;
      tf=mainstruct.lister[nr].first_filter;
      mainstruct.lister[nr].first_filter=localf;
      localf=tf;
      for(i=0,newmode=-1,k=0;i<LISTER_MODES;i++) {
        if(mainstruct.mode_info[i].selectable==TRUE) {
          if(cbmode[k]->data==HIGH) {
            newmode=i;
          }
          k++;
        }
      }
      a=mainstruct.lister[nr].activemode;
      if(a==newmode) {
        if(a>=0) {
          prog=mainstruct.mode_info[a].update;
          if(prog!=NULL) (prog)(nr);
        }
      } else {
        /* auf newmode Schalten */
        if(a>=0) {
          prog=mainstruct.mode_info[a].off;
          if(prog!=NULL) (prog)(nr);
        }
        if(newmode>=0) {
          prog=mainstruct.mode_info[newmode].on;
          if(prog!=NULL) (prog)(nr);
        }
      }
    } else if(cancel==TRUE) {
    }
    _CloseWindow(wins[2]);
    _CloseWindow(wins[1]);
    _CloseWindow(wins[0]);
    _CloseWindow(gfxwin);
  }
  while(localf!=NULL) {
    _freesafe(localf->pattern);
    tf=localf->next;
    _freesafe(localf);
    localf=tf;
  }
  _Check4Filters();
}

bool _RequestActionFlags(long *flag,int commando)
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *button;
  int w,w2,h,x;
  int p,e;
  KeySym key;
  bool returnvalue=FALSE;
  _ChooseButton *cb[FLAGNR];    /* Mehr als ich brauch, aber es geht glaube ich nicht anders */
  w=0;
  for(x=1;x<flaginfo[commando][0];x++) {
    w2=strlen(_localeflags[flaginfo[commando][1]+x-1])+2;
    w2*=_CharWidth;
    w2+=20+_BBH;
    if(w2>w) w=w2;
  }
  h=flaginfo[commando][0]*(_BBH+10)+10;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,0,_locale[123],PMinSize|PMaxSize,NULL);
  if(gfxwin==NULL) {printf("No memory\n");return FALSE;}
  for(x=0;x<(flaginfo[commando][0]-1);x++) {
    p=pow(2,x);
    e=*flag&p;
    e=e/p;
    cb[x]=_CreateChooseButton(gfxwin,10,10+10*x+_BBH*x,_BBH,_BBH,e,x);
    _CreateText(gfxwin,10+_BBH+5,10+10*x+_BBH*x+_CharHeight+1,1,_localeflags[flaginfo[commando][1]+x]);
  }
  _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",-1);
  _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",-2);
  _RedrawWin(gfxwin);
  for(;;) {
    msg=_WaitMessage(gfxwin);
    if(msg!=NULL) {
      if(msg->type==ButtonRelease) {
        if(msg->gadgettype==BUTTON_GADGET) {
          button=(_Button*)msg->gadget;
          if(button->data==-1) {
            returnvalue=TRUE;
            for(x=0;x<(flaginfo[commando][0]-1);x++) {
              e=cb[x]->data;
              p=pow(2,x);
              if(e==0) {
                *flag=*flag&(0xffffffff-p);
              } else {
                *flag=*flag|p;
              }
            }
          } else if(button->data==-2) {
            returnvalue=FALSE;
          }
          if((button->data==-1)||(button->data=-2)) {
            _ReplyMessage(msg);
            break;
          }
        }
      } else if(msg->type==KeyRelease) {
        key=msg->key;
        if((key>48)&&(key<57)) {
          key=key-49;
          if(key<(flaginfo[commando][0]-1)) {
            e=cb[key]->data;
            if(e==1) cb[key]->data=0; else cb[key]->data=1;
            _RedrawWin(gfxwin);
          }
        } else if(key==XK_Return) {
          returnvalue=TRUE;
          for(x=0;x<(flaginfo[commando][0]-1);x++) {
            e=cb[x]->data;
            p=pow(2,x);
            if(e==0) {
              *flag=*flag&(0xffffffff-p);
            } else {
              *flag=*flag|p;
            }
          }
          _ReplyMessage(msg);
          break;
        } else if(msg->key==XK_Escape) {
          returnvalue=FALSE;
          _ReplyMessage(msg);
          break;
        }
      } else if(msg->type==ClientMessage) {
        if(msg->gadgettype==CLOSE_GADGET) {
          if(msg->window==gfxwin->Wnd) {
            returnvalue=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
      }
      _ReplyMessage(msg);
    }
  }
  _CloseWindow(gfxwin);
  return returnvalue;
}

char *_RequestNewName(char *oldname)
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *nnsg;
  int w,h;
  char *tstr,*newname;
  bool okay=FALSE;

  w=strlen(_locale[148])+strlen(oldname);
  w*=_CharWidth;
  w+=20;
  h=3*_BBH+3*10;
  newname=NULL;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,_locale[149],PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    tstr=(char*)_allocsafe(strlen(_locale[148])+strlen(oldname));
    sprintf(tstr,_locale[148],oldname);
    _CreateText(gfxwin,10,5+_CharHeight,1,tstr);
    _freesafe(tstr);
    nnsg=_CreateStringGadget(gfxwin,10,10+_BBH,w-20,_NBH+6,oldname,256,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,3);
    _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    _HandleStringGadget(gfxwin,nnsg,NULL);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) okay=TRUE;
            else if(tbutton->data==2) okay=FALSE;
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            okay=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            okay=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(okay==TRUE) {
      newname=(char*)_allocsafe(strlen(nnsg->string)+1);
      if(newname!=NULL) {
        strcpy(newname,nnsg->string);
      }
    } else {
      newname=NULL;
    }
    _CloseWindow(gfxwin);
  }
  if(newname!=NULL) {
    if(strlen(newname)<1) {
      _freesafe(newname);
      newname=NULL;
    }
  }
  return newname;
}

char *_CreateTMPName()
{
  char *returnstr,buffer[128];
  int rannr;

  rannr=rand();
  sprintf(buffer,"%d",rannr);
  returnstr=(char*)_allocsafe(11+strlen(buffer)+1);
  sprintf(returnstr,"/tmp/worker%s",buffer);
  return returnstr;
}

void _Check4Filters()
{
  /* berprft, ob ein Filter aktiv ist und stellt dann dem LVB ein Stern davor */
  _Filter *filter;
  int nr,exist;
  bool changed;
  char *tstr,*text;
  struct _button *lvb;

  for(nr=0;nr<2;nr++) {
    filter=mainstruct.lister[nr].first_filter;
    lvb=mainstruct.lister[nr].lvb;
    exist=0;
    while(filter!=NULL) {
      if(filter->check!=0) exist=1;
      filter=filter->next;
    }
    changed=FALSE;
    if(exist==1) {
      text=lvb->text_normal;
      if(text[0]!='*') {
        tstr=(char*)_allocsafe(strlen(text)+2);
        sprintf(tstr,"*%s",text);
        _freesafe(text);
        lvb->text_normal=tstr;
        changed=TRUE;
      }
    } else {
      text=lvb->text_normal;
      if(text[0]=='*') {
        tstr=(char*)_allocsafe(strlen(text));
        sprintf(tstr,"%s",text+1);
        _freesafe(text);
        lvb->text_normal=tstr;
        changed=TRUE;
      }
    }
    if(changed==TRUE) {
      _GUIDrawButton(mainwin,lvb,NORMAL,FALSE,BUFFER);
      _FlushWin(mainwin,lvb->x,lvb->y,lvb->width,lvb->height);
    }
  }
}

void _ALL_ChangeListerOptions(int pointerinfo,void *info)
{
  unsigned long flag;
  int nr;
  if(pointerinfo==PISBUTTON) {
    flag=((struct _buttondef*)info)->flag1;
  } else if(pointerinfo==PISFILETYPE) {
    flag=((struct _filetypedef*)info)->flag1;
  } else if(pointerinfo==PISHOTKEY) {
    flag=((struct _hotkeydef*)info)->flag1;
  } else {
    flag=0;
  }
  nr=mainstruct._ActiveLV;
  if((flag&1)==1) nr=0;
  if((flag&2)==2) nr=1;
  if(nr>=0) {
    _ChangeListerSets(nr);
  }
}

void _ALL_ListerScrollLeft(int pointerinfo,void *info)
{
  int nr;
  _ListView *lv;

  nr=mainstruct._ActiveLV;
  if(nr>=0) {
    lv=mainstruct.lister[nr].lv;
    if(lv->hbar_startpos>0) {
      lv->hbar_startpos--;
      _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
      _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
    }
  }
}

void _ALL_ListerScrollRight(int pointerinfo,void *info)
{
  int nr,eff_width,maxdisplayh;
  _ListView *lv;

  nr=mainstruct._ActiveLV;
  if(nr>=0) {
    lv=mainstruct.lister[nr].lv;
    eff_width=lv->width-4;
    if(lv->vbar==TRUE) {
      eff_width=eff_width-lv->vbar_width;
    }
    maxdisplayh=_MaxDisplayH(mainwin,eff_width);
    if((lv->maxlength-lv->hbar_startpos)>maxdisplayh) {
      lv->hbar_startpos++;
      _GUIDrawListView(mainwin,lv,LV_NORMAL,BUFFER);
      _FlushWin(mainwin,lv->x,lv->y,lv->width,lv->height);
    }
  }
}


char *StringRequest(char *oldname,char *title,char *text)
{
  _GfxWin *gfxwin;
  _Message *msg;
  _Button *tbutton;
  _StringGadget *nnsg;
  int w,h;
  char *newname;
  bool okay=FALSE;

  w=strlen(text)+strlen(oldname);
  w*=_CharWidth;
  w+=20;
  h=3*_BBH+3*10;
  newname=NULL;
  gfxwin=_OpenWindow(NULL,0,0,w,h,w,w,w,h,h,h,_WConfig.requestbg,title,PMinSize|PMaxSize,NULL);
  if(gfxwin!=NULL) {
    _CreateText(gfxwin,10,5+_CharHeight,1,text);
    nnsg=_CreateStringGadget(gfxwin,10,10+_BBH,w-20,_NBH+6,oldname,256,_WConfig.unsel_pathfg,_WConfig.unsel_pathbg,_WConfig.sel_pathfg,_WConfig.sel_pathbg,3);
    _CreateButton(gfxwin,10,h-5-_BBH,(strlen(_locale[11])+2)*_CharWidth,_BBH,_black,0,_locale[11],FALSE,_white,2,"",1);
    _CreateButton(gfxwin,w-10-(strlen(_locale[8])+2)*_CharWidth,h-5-_BBH,(strlen(_locale[8])+2)*_CharWidth,_BBH,_black,0,_locale[8],FALSE,_white,2,"",2);
    _RedrawWin(gfxwin);
    _HandleStringGadget(gfxwin,nnsg,NULL);
    for(;;) {
      if((msg=_WaitMessage(gfxwin))!=NULL) {
        if(msg->type==ButtonRelease) {
          if(msg->gadgettype==BUTTON_GADGET) {
            tbutton=(_Button*)msg->gadget;
            if(tbutton->data==1) okay=TRUE;
            else if(tbutton->data==2) okay=FALSE;
            if((tbutton->data==1)||(tbutton->data==2)) {
              _ReplyMessage(msg);
              break;
            }
          }
        } if(msg->type==KeyRelease) {
          if(msg->key==XK_Return) {
            okay=TRUE;
            _ReplyMessage(msg);
            break;
          } else if(msg->key==XK_Escape) {
            okay=FALSE;
            _ReplyMessage(msg);
            break;
          }
        }
        _ReplyMessage(msg);
      }
    }
    if(okay==TRUE) {
      newname=(char*)_allocsafe(strlen(nnsg->string)+1);
      if(newname!=NULL) {
        strcpy(newname,nnsg->string);
      }
    } else {
      newname=NULL;
    }
    _CloseWindow(gfxwin);
  }
  if(newname!=NULL) {
    if(strlen(newname)<1) {
      _freesafe(newname);
      newname=NULL;
    }
  }
  return newname;
}
